diff -uNrd ircd-hybrid-6.0/tools/mkpasswd.c ircd-pi1.0a/tools/mkpasswd.c
--- ircd-hybrid-6.0/tools/mkpasswd.c	Tue Aug 10 19:07:25 1999
+++ ircd-pi1.0a/tools/mkpasswd.c	Sun May  5 22:48:33 2002
@@ -3,44 +3,41 @@
  * You can use this code as long as my name stays with it.
  *
  *
- * $Id: mkpasswd.c,v 1.4 1999/08/10 23:07:25 lusky Exp $
+ * $Id: mkpasswd.c,v 1.6 2002/05/06 02:48:33 smoli Exp $
  */
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 #include <time.h>
+#include <unistd.h>
+#include <crypt.h>
 
-
-extern char *getpass();
-extern char *crypt();
-/* extern long random(); */
-/* extern int srandom(unsigned); */
-
-int main(argc, argv)
-int argc;
-char *argv[];
+int main()
 {
   static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
   char salt[3];
-  char * plaintext;
+  long seed;
+  char *plaintext, *passwd;
 
-  if (argc < 2) {
-    srandom(time(0));		/* may not be the BEST salt, but its close */
-    salt[0] = saltChars[random() % 64];
-    salt[1] = saltChars[random() % 64];
-    salt[2] = 0;
-  }
-  else {
-    salt[0] = argv[1][0];
-    salt[1] = argv[1][1];
-    salt[2] = '\0';
-    if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
-      fprintf(stderr, "illegal salt %s\n", salt), exit(1);
-  }
+  plaintext = getpass("Password: ");
 
-  plaintext = getpass("plaintext: ");
+  seed = time(NULL);
 
-  printf("%s\n", crypt(plaintext, salt));
+  for(;;)
+    { 
+      srandom(seed);
+      salt[0] = saltChars[random() % 64];
+      salt[1] = saltChars[random() % 64];
+      salt[2] = 0;
+      passwd = crypt(plaintext, salt);
+      if(!strchr(passwd, '.') &&
+         !strchr(passwd, '/'))
+        break;
+      seed -= 0x9e45ba93;
+      seed ^= seed - 0x9e45ba93;
+    }
+
+  printf("%s\n", passwd);
   return 0;
 }
 
